/*
 =========================================================================================================
 C. Voglis, Department of Computer Science,
 Univeristy of Ioannina, Greece

 File: 				SOURCE_problems.h
 Usage: 			Definitions for test function collection
 Last Modified: 	21/08/2013
 =========================================================================================================
 */
#ifndef _SOURCE_PROBLEMS_H_
#define _SOURCE_PROBLEMS_H_

#include "data.h"

double Shifted_Sphere( int dim , double* x );
double Schwefel_Problem( int dim , double* x );
double Shifted_Rosenbrock( int dim , double* x );
double Shifted_Rastrigin( int dim , double* x );
double Shifted_Griewank( int dim , double* x );
double Shifted_Ackley( int dim , double* x );
double Shifted_Weierstrass( int dim , double* x );
void func(int func_number , int dim , double* x, double *fx);

extern void copy_vector (int size, double X[], double Y[]);
extern double norms (int dim, double X[], int WhichNorm);
void Objective_F (double X[], int N, double *F);

static double pi;
static double e;

#endif
