#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netdb.h>


/*************************************************************************/
/**************************   HELPER ROUTINES   **************************/
/*************************************************************************/

int recv_all(int fd, void *buffer, unsigned int size)
{
	int result;
	unsigned int s=size;
	char *pos = (char*)buffer;
	

	do {
		result=recv(fd,pos,s,0);
		if((result!=-1)&&(result>0)) {
			s -= result;
			pos += result;
		}
		else 
			return result; //-1;
	} while (s>0);
	return size;
}


int send_all(int fd, void *buffer, unsigned int size)
{
	int result;
	unsigned int s=size;
	char *pos = (char*)buffer;
	
	do {
		result=send(fd,pos,s,0);
		if((result!=-1)&&(result>0)) {
			s -= result;
			pos += result;
		}
		else return result; //-1;
	} while (s>0);
	return size;
}


double my_gettime()
{
        struct timeval tv;
        gettimeofday(&tv, 0);
        return (double) (tv.tv_sec+tv.tv_usec/1000000.0);
}
