/*
 =========================================================================================================
 C. Voglis, Department of Computer Science, 
 Univeristy of Ioannina, Greece

 File: 			SOURCE_local_opt.h
 Usage: 		External definition of local searches
 Last Modified: 21/08/2013
 =========================================================================================================
 */

#ifndef _SOURCE_LOCAL_OPT_H_
#define _SOURCE_LOCAL_OPT_H_

extern void mds(double *point, int n, double *val, double eps, int maxfevals, int maxiter,
		double mu, double theta, double delta, int *nf, double *xl, double *xr, int *term);

extern /* Subroutine */ int bfgsmv_(double *, double *, double *, int *, double *, int *, double *,
		double *, int *, double *, int *, double *, double *, int *, double *, int *, int *, int *,
		int *, int *, int *, int *, double *, double *, int *, int *, double *, double *, double *,
		double *, int, int);

#endif
