#include <stdio.h>
#include <stdlib.h>

void ondl1f(double *x, int n, double *xl, double *xu, double feps, int iprint, double *g, int *noc);
void ondl1q(double *x, int n, double *xl, double *xu, double feps, int iprint, double *g, int *noc);

void ondlga_(double *x, int *n, double *xl, double *xu, 
	double *feps, int *iord, int *iprint, double *g, int *noc, int *ierr)
{
	if (*iprint == 3) printf(" PNDL: N=%d FEPS=%21.14lf IORD=%d\n", 
				*n, *feps, *iord);

	if (*iord == 1)
		ondl1f(x,*n,xl,xu,*feps,*iprint,g,noc);
	else if (*iord == 2)
		ondl1q(x,*n,xl,xu,*feps,*iprint,g,noc);
	else {
		printf("pndlga_: invalid order (%d)\n", *iord);
		exit(1); 
	}
	*ierr = 0;

	return;
}
